<style scoped>


    .button-group {
        float: right;
    }
</style>

<template>
    <v-expansion-panel class="RuleItem" expand  >
        <v-expansion-panel-content expand-icon="arrow_drop_down" isActive="open">
            <div slot="header">
                <span>
                    <v-tooltip right>
                        <span slot="activator">
                            {{ model.name }}
                        </span>
                        <span>
                            {{ model.toolTipText }}
                        </span>
                    </v-tooltip>
                </span>
                <span class="button-group">
                    <v-btn icon >
                        <v-icon color="green">check_box</v-icon>
                    </v-btn>
                    <v-btn icon>
                        <v-icon color="blue">play_circle_filled</v-icon>
                    </v-btn>
                    <v-btn @click="addChild" icon>
                        <v-icon>remove_red_eye</v-icon>
                    </v-btn>
                    <v-btn @click="toggle" icon>
                        <v-icon>add_box</v-icon>
                    </v-btn>
                </span>
            </div>
            <div v-if="isFolder">
                <RuleSet class="item"
                         v-for="(model, index) in model.children"
                         :key="index"
                         :model="model">
                </RuleSet>
            </div>
            <div v-else>
                <v-card>
                    No more rules, leaf settings here
                </v-card>
            </div>
        </v-expansion-panel-content>
    </v-expansion-panel>
</template>

<script>


    export default {
        props: {
            model: Object
        },
        data: function () {
            return {
                open: false,
            }
        },
        name: "RuleSet",

        computed: {
            isFolder: function () {
                return this.model.children &&
                    this.model.children.length
            }
        },
        methods: {
            toggle: function () {
                if (this.isFolder) {
                    this.open = !this.open
                }
            },
            changeType: function () {
                if (!this.isFolder) {
                    Vue.set(this.model, 'children', [])
                    this.addChild()
                    this.open = true
                }
            },
            addChild: function () {
                this.model.children.push({
                    name: 'new Rule'
                })
            }

        }
    }


</script>
